<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "state".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "State".
 *
 * Columns in table "state" available as properties of the model,
 * followed by relations of table "state" available as properties of the model.
 *
 * @property integer $id
 * @property integer $country_id
 * @property integer $is_pending_approval
 * @property string $name
 * @property string $abbreviation
 * @property string $friendly_url
 *
 * @property City[] $cities
 * @property PracticeDetails[] $practiceDetails
 * @property Country $country
 */
abstract class BaseState extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'state';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'State|States', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, abbreviation, friendly_url', 'required'),
            array('country_id, is_pending_approval', 'numerical', 'integerOnly' => true),
            array('name', 'length', 'max' => 50),
            array('abbreviation', 'length', 'max' => 5),
            array('friendly_url', 'length', 'max' => 255),
            array('country_id, is_pending_approval', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, country_id, is_pending_approval, name, abbreviation, friendly_url', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'cities' => array(self::HAS_MANY, 'City', 'state_id'),
            'practiceDetails' => array(self::HAS_MANY, 'PracticeDetails', 'coverage_state_id'),
            'country' => array(self::BELONGS_TO, 'Country', 'country_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'country_id' => null,
            'is_pending_approval' => Yii::t('app', 'Is Pending Approval'),
            'name' => Yii::t('app', 'Name'),
            'abbreviation' => Yii::t('app', 'Abbreviation'),
            'friendly_url' => Yii::t('app', 'Friendly Url'),
            'cities' => null,
            'practiceDetails' => null,
            'country' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('country_id', $this->country_id);
        $criteria->compare('is_pending_approval', $this->is_pending_approval);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('abbreviation', $this->abbreviation, true);
        $criteria->compare('friendly_url', $this->friendly_url, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
